<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: file_watcher.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('file__watcher_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">file_watcher.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;filesystem&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classFileWatcher.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFileWatcher.html">FileWatcher</a> {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    std::chrono::duration&lt;int, std::milli&gt; delay;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="classFileWatcher.html#a46e9cd09061f1411bcbcc02e54dc2e2c">FileWatcher</a>(std::string file_to_watch, std::chrono::duration&lt;int, std::milli&gt; delay);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFileWatcher.html#a5f1c6b365b0f4ad868d1d6651508b47f">start</a>(<span class="keyword">const</span> std::function&lt;<span class="keywordtype">void</span> ()&gt; &amp;action);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFileWatcher.html#ab4c0c9f77ef132ba0107ce73c4b3b7bd">stop</a>();</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    std::filesystem::file_time_type file_time;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    std::string file_to_watch;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    std::thread thread;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">bool</span> running_ = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;};</div>
<div class="ttc" id="aclassFileWatcher_html"><div class="ttname"><a href="classFileWatcher.html">FileWatcher</a></div><div class="ttdef"><b>Definition:</b> file_watcher.hpp:19</div></div>
<div class="ttc" id="aclassFileWatcher_html_a46e9cd09061f1411bcbcc02e54dc2e2c"><div class="ttname"><a href="classFileWatcher.html#a46e9cd09061f1411bcbcc02e54dc2e2c">FileWatcher::FileWatcher</a></div><div class="ttdeci">FileWatcher(std::string file_to_watch, std::chrono::duration&lt; int, std::milli &gt; delay)</div><div class="ttdoc">Construct a new File Watcher for specified file.</div><div class="ttdef"><b>Definition:</b> file_watcher.cpp:20</div></div>
<div class="ttc" id="aclassFileWatcher_html_a5f1c6b365b0f4ad868d1d6651508b47f"><div class="ttname"><a href="classFileWatcher.html#a5f1c6b365b0f4ad868d1d6651508b47f">FileWatcher::start</a></div><div class="ttdeci">void start(const std::function&lt; void()&gt; &amp;action)</div><div class="ttdoc">Monitor &quot;file_to_watch&quot; for changes and in case of a change execute the user supplied &quot;action&quot; functi...</div><div class="ttdef"><b>Definition:</b> file_watcher.cpp:29</div></div>
<div class="ttc" id="aclassFileWatcher_html_ab4c0c9f77ef132ba0107ce73c4b3b7bd"><div class="ttname"><a href="classFileWatcher.html#ab4c0c9f77ef132ba0107ce73c4b3b7bd">FileWatcher::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Stops Listener.</div><div class="ttdef"><b>Definition:</b> file_watcher.cpp:47</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_a7bb9b575703809b9fbb7ad7f723668f.html">local_app</a></li><li class="navelem"><a class="el" href="dir_d88d79efde80b6be31bde64d01fcf743.html">general_tools</a></li><li class="navelem"><a class="el" href="dir_b285aa251bdd6d1bd09ddb4753f35972.html">include</a></li><li class="navelem"><b>file_watcher.hpp</b></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
